SystemOrganization addCategory: #'TKSave-Apps'!
SystemOrganization addCategory: #'TKSave-Base'!
SystemOrganization addCategory: #'TKSave-Tests'!
SystemOrganization addCategory: #'TKSave-Connection'!

!String methodsFor: '*tksave' stamp: 'tk 5/15/2008 15:45'!
asDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('description',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:46'!
magritteDescriptionClass
	^#MAStringDescription! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:50'!
magritteDescriptionDefaultValue
	^''''''! !

REServe subclass: #REServeTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!REServeTestObject class methodsFor: 'as yet unclassified' stamp: 'tk 5/7/2008 17:32'!
tableDefinition
	^super tableDefinition
		column: #testInteger as: Integer;
		column: #testString as: String;
		column: #testSomething as: Float;
		column: #testDate as: DateAndTime.! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testDate
	^ testDate! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testDate: anObject
	testDate := anObject! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testInteger
	^ testInteger! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testInteger: anObject
	testInteger := anObject! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testSomething
	^ testSomething! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testSomething: anObject
	testSomething := anObject! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testString
	^ testString! !

!REServeTestObject methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:35'!
testString: anObject
	testString := anObject! !

REServeTestObject subclass: #REServeTestObjectChild
	instanceVariableNames: 'blub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!REServeTestObjectChild class methodsFor: 'as yet unclassified' stamp: 'tk 5/7/2008 17:33'!
tableDefinition
	^super tableDefinition
		column: #blub as: String.! !

!REServeTestObjectChild methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:36'!
blub
	^ blub! !

!REServeTestObjectChild methodsFor: 'accessing' stamp: 'tk 5/7/2008 17:36'!
blub: anObject
	blub := anObject! !

!MADescription methodsFor: '*tksave' stamp: 'tk 6/9/2008 15:16'!
persistenceDescription
	^self propertyAt: #persistenceDescription ifAbsent: [nil]! !

!MADescription methodsFor: '*tksave' stamp: 'tk 6/9/2008 15:16'!
persistenceDescription: aTKSaveTableOrColumn
	^self propertyAt: #persistenceDescription put: aTKSaveTableOrColumn.! !

TestCase subclass: #TKSaveBaseTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:20'!
setUp
	| |
	"setup a MySQL connection - so basically this should be a different test"
	connection := REServeMySQLDriver onHost: 'localhost' port: 3306 withUser: 'thomas'  password: 'test' database: 'squeak_test'.
	connection resetDatabase.
	TKSaveTestObject instVarNames do: [ :ivn |
		(TKSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [
			TKSaveTestObject class removeSelector: ivn asDescriptionSelector.
		].
	].
	! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 16:57'!
testNewRecordAttribute
	
	| obj |
	obj := TKSaveTestObject new.
	obj testInteger: 5.
	self assert: (obj newRecord).
	obj save.
	self assert: (obj newRecord not).
	"obj2 := TKSaveTestObject findByTestInteger: 2.
	self assert: (obj2 newRecord)."
	
	! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 17:03'!
testSaveMagritteDescriptorCreation
	| testObject |

	testObject := TKSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: (TKSaveTestObject class includesSelector: ('testDate' asDescriptionSelector)).
	self assert: (TKSaveTestObject class includesSelector: ('testInteger' asDescriptionSelector)).
	self assert: (TKSaveTestObject class includesSelector: ('testString' asDescriptionSelector)).
	self assert: ((TKSaveTestObject class includesSelector: ('testSomething' asDescriptionSelector)) not).
	self assert: (TKSaveTestObject descriptionTestString class = MAStringDescription).
	self assert: (TKSaveTestObject descriptionTestDate class = MADateDescription).
	self assert: (TKSaveTestObject descriptionTestInteger class = MANumberDescription).
	! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:22'!
testSaveMagrittePersistenceDescriptorCreation
	
	| testObject description |
	testObject := TKSaveTestObject new.
	testObject testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: (TKSaveTestObject new).
	testObject save.
	description := TKSaveTestObject descriptionTestInteger persistenceDescription.
	self assert: (description class = TKSaveColumn).
	self assert: (description sqlType = 'SMALLINT').
	self assert: (description columnName = 'testInteger').
	self assert: (description associatedClass isNil). ! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 13:29'!
testSaveNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := TKSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	searchResult0 := TKSaveTestObject findByTestInteger: 5 andTestDate: Date today.
	searchResult1 := TKSaveTestObject findByTestInteger: 5.
	searchResult2 := TKSaveTestObject findByTestDate: Date today andTestString: 'test'.
	searchResult3 := TKSaveTestObject findByTestString: 'test'.
	self assert: (searchResult0 testInteger = 5).
	self assert: (searchResult0 testDate = Date today).
	self assert: (searchResult0 testString = 'test').
	self assert: (testObject = searchResult1).
	self assert: (testObject = searchResult2).
	self assert: (testObject = searchResult3).
	! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 16:32'!
testSaveObjectIdAssignment
	| testObject testObject2 |
	
	testObject := TKSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: (testObject oid == 1).
	
	testObject2 := TKSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save. 
	self assert: (testObject2 oid == 2).
	! !

!TKSaveBaseTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 17:07'!
testSaveTableCreation
	| testObject |
	
	self assert: (TKSaveTestObject tableForClassExists) not.
	testObject := TKSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: (TKSaveTestObject tableForClassExists).
	
	! !

TestCase subclass: #TKSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveColumnTest methodsFor: 'as yet unclassified' stamp: 'tk 6/9/2008 14:39'!
testCreationCode
	| column column2 |
	column := TKSaveColumn new.
	column columnName: 'testColumn'.
	column sqlType: 'INTEGER'.
	
	column2 := Compiler evaluate: column creationCode.
	self assert: (column2 class = TKSaveColumn).
	self assert: (column2 sqlType = 'INTEGER').
	self assert: (column2 columnName = 'testColumn').! !

TestCase subclass: #TKSaveConnectionManagerTest
	instanceVariableNames: 'connectionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveConnectionManagerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:58'!
setUp
	connectionManager := TKConnectionManager getInstance.! !

!TKSaveConnectionManagerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:28'!
testAddConnectionSpecification
	| connectionSpecification connection |
	connectionManager connectionSpecificationDictionary: Dictionary new.
	connectionSpecification := TKConnectionSpecification user: 'thomas' password: 'test' port: 3306 database: 'squeak_test' hostname: 'localhost' driver: #REServeMySQLDriver.  
	connectionManager setupConnectionSpecification:  connectionSpecification for: 'TKSave'.
	self assert: (connectionManager connectionSpecificationDictionary includesKey: 'TKSave').
	self assert: ((connectionManager connectionSpecificationDictionary at: 'TKSave') class == TKConnectionSpecification).
	connection := connectionManager getConnectionForCategory: 'TKSave'.
	self assert: (connection isNil not)
	! !

TestCase subclass: #TKSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveDescriptionHandlerTest methodsFor: 'as yet unclassified' stamp: 'tk 6/6/2008 16:55'!
testSqlTypeRecognition
	| handler |
	handler := TKSaveDescriptionHandler for: (TKSaveTestObject new).
	self assert: ((handler determineSqlTypeForObject: 42) = 'SMALLINT').
	self assert: ((handler determineSqlTypeForObject: TKSaveTestObject new) = 'INTEGER').
	self assert: ((handler determineSqlTypeForObject: TKSaveTable new) isNil).
	self assert: ((handler determineSqlTypeForObject: true) = 'BOOLEAN')! !

TestCase subclass: #TKSaveMagritteDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveMagritteDescriptionHandlerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 13:32'!
setUp
	TKSaveTestObject instVarNames do: [ :ivn |
		(TKSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [
			TKSaveTestObject class removeSelector: ivn asDescriptionSelector.
		].
	].! !

!TKSaveMagritteDescriptionHandlerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 13:29'!
testCreateDescriptionMethods
	| obj |
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestInteger) not).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestString) not).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestDate) not).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestSomething) not).
	obj := TKSaveTestObject new.
	obj testInteger: 42.
	obj testString: 'test'.
	obj testDate: Date today.
	(TKSaveMagritteDescriptionHandler for: obj) createDescriptionMethods.
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestInteger)).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestString)).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestDate)).
	self assert: ((TKSaveTestObject respondsTo: #descriptionTestSomething) not).	! !

TestCase subclass: #TKSaveSimpleDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveSimpleDescriptionHandlerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 13:38'!
setUp
	(TKSaveSimpleTestObject class includesSelector: #tableDefinition) ifTrue: [
			TKSaveSimpleTestObject class removeSelector: #tableDefinition.
	].! !

!TKSaveSimpleDescriptionHandlerTest methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 13:40'!
testCreateDescriptionMethods
	| obj |
	self assert: ((TKSaveSimpleTestObject class includesSelector: #tableDefinition) not).
	obj := TKSaveSimpleTestObject new.
	obj testInteger: 2;
		testString: 'bla';
		testDate: Date today;
		testSomething: TKSaveTestObject new.
	(TKSaveSimpleDescriptionHandler for: obj) createDescriptionMethods.
	self assert: (TKSaveSimpleTestObject class includesSelector: #tableDefinition).! !

TestCase subclass: #TKSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveStringExtensionTests methodsFor: 'as yet unclassified' stamp: 'tk 5/15/2008 15:46'!
testAsDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionAInstanceVariable).
	! !

WAComponent subclass: #TKTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Apps'!

!TKTestComponent class methodsFor: 'as yet unclassified' stamp: 'tk 4/29/2008 15:44'!
canBeRoot
	^true! !

!TKTestComponent methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 14:44'!
renderContentOn: html
	html anchor
		callback: [self call: TKSaveTestObject new asComponent addValidatedForm];
		with: 'new'.! !

Object subclass: #TKConnectionManager
	instanceVariableNames: 'connectionSpecificationDictionary connectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

TKConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

TKConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

!TKConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:35'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!TKConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!TKConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!TKConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!TKConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!TKConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/6/2008 10:31'!
getConnectionForCategory: aCategoryName
	| cSpec  |
	cSpec := self connectionSpecificationDictionary at: aCategoryName ifAbsent: nil.
	cSpec ifNotNil: [
		^self getConnectionFromQueue: aCategoryName for: cSpec.
	].
	self error: 'no connection data specified'.
	^nil
	! !

!TKConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 18:03'!
getConnectionFromQueue: aCategoryName for: aConnectionSpecification
	| availableConnections |
	availableConnections := self connectionPool at: aCategoryName ifAbsent: nil.
	availableConnections ifNil: [
	self connectionPool at: aCategoryName put: {((Smalltalk at: aConnectionSpecification driverClass) 
			onHost: aConnectionSpecification hostname 
			port: aConnectionSpecification port  
			withUser: aConnectionSpecification username  
			password: aConnectionSpecification password  
			database: aConnectionSpecification database)}
	].
	^availableConnections first.
	! !

!TKConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:37'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.! !

!TKConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:42'!
setupConnectionSpecification: aConnectionSpecification for: aCategoryName
	self connectionSpecificationDictionary at: aCategoryName put: aConnectionSpecification! !

Object subclass: #TKConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!TKConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!TKConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!TKConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #TKSaveBase
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:06'!
columnNameForInstVar: ivarName
	^ivarName! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:16'!
createClassDescriptionFor: aSampleObject
	(self descriptionHandler for: aSampleObject) createDescriptionMethods.! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:14'!
createTableForClassBasedOn: aSampleObject
	self createClassDescriptionFor: aSampleObject.
	self getConnection createTableFor: aSampleObject withName: self tableName.
	! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:16'!
descriptionHandler
	^TKSaveMagritteDescriptionHandler! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 13:49'!
doesNotUnderstand: aMessage
	| selector all attributes finderMethod startWord |
	selector := aMessage selector.
	finderMethod := selector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := selector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		all ifTrue:[startWord := 'findAllBy'] ifFalse: [startWord := 'findBy'].
		attributes := self findAttributesInSelector: aMessage selector beginWith: startWord.
		attributes ifNil: [
			^super doesNotUnderstand: aMessage.
		] ifNotNil: [
			^self performSearchFor: attributes withValues: (aMessage arguments) andReturnAll: all.
		].
	] ifFalse: [
		^super doesNotUnderstand: aMessage.
	].
	
	
	! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 13:50'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements at: 1) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName at: 1 put: ((attrName at: 1) asLowercase).
		(self allInstVarNames includes: attrName) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [
			^nil
		]
	].
	^searchedAttributes! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/6/2008 10:34'!
getConnection
	^TKConnectionManager getInstance getConnectionForCategory: ((self category subStrings: '-') first). ! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 14:08'!
notPersistedInstVars
	^#()! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:20'!
performSearchFor: attributes withValues: arguments andReturnAll: aBool
	| limit argumentAttributeDictionary results |
	aBool ifFalse: [limit := 1].
	argumentAttributeDictionary := Dictionary new.
	attributes withIndexDo: [:attr :index | 
		argumentAttributeDictionary at: attr put: (arguments at: index).
	].
	results := 
		self getConnection queryForObjectsOf: self 
			byAttributes: argumentAttributeDictionary 
			inTable: self tableName 
			withLimit: limit.
	aBool ifTrue: [^results] ifFalse: [^results first] 
	
	
	! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 16:50'!
persistedInstVars
	| subClassVars |
	subClassVars := Set new.
	((self descriptionHandler getInheritanceModeForClass: self) = #singleTableInheritance) ifTrue: [
		self allSubclasses do: [:subClass | subClassVars addAll: subClass persistedInstVars].
	].
	^(self instVarNames difference: self notPersistedInstVars) union: (subClassVars).	
	! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:25'!
reServeType
	^#unsignedInteger! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:51'!
tableDefinition
	^REServeTableDefinition new 
		column: #oid 
		as: #Integer.! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/13/2008 15:34'!
tableForClassExists
	^self getConnection queryForTableExistance: self tableName.! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/13/2008 15:48'!
tableName
	^self name asString asEscapedSql.! !

!TKSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/20/2008 14:14'!
useInstVarAccessors
	^false! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:29'!
= anObject
	(anObject isKindOf: (self class)) ifFalse:[
		^false.
	].
	^anObject oid = self oid.! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:28'!
asSqlValueString
	^(self oid) asSqlValueString! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/26/2008 15:17'!
createRecord
	self oid: (self class getConnection createObject: self).! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 13:32'!
escapedValueForInstanceVariable: iVar
	| ivarValue |
	ivarValue := self getValueOfInstVarNamed: iVar.
	(ivarValue class inheritsFrom: TKSaveBase) ifTrue: [
		(ivarValue isDirty) ifTrue: [ivarValue save]	
	].
	(ivarValue respondsTo: #asSqlValueString) ifTrue: [
		^ivarValue asSqlValueString.
	] ifFalse: [
		self error: 'unstorable instance variable of type',ivarValue class name,'!! Implement #asSqlValueString'.
	].! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 11:52'!
getValueOfInstVarNamed: iVar
	| ivarValue |
	(self respondsTo: iVar asSymbol) ifTrue: [
		(self class useInstVarAccessors) ifTrue: [
			ivarValue := self perform: iVar asSymbol.	
		] ifFalse: [
			ivarValue := self instVarNamed: iVar asSymbol.
		]
	].
	^ivarValue! !

!TKSaveBase methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!TKSaveBase methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:56'!
oid
	^oid! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:57'!
oid: anInteger
	oid := anInteger.! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 13:44'!
save
	" check if the table already exisits - this is for dev mode only - FACTOR OUT"
	self class tableForClassExists ifTrue: [
	
	] ifFalse: [
		self class createTableForClassBasedOn: self.
	].

	"update the record if it is already present in the database, otherwhise create it"
	self newRecord ifTrue: [
		self createRecord.
	] ifFalse: [
		self updateRecord.
	]! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 11:30'!
setInstVarNamed: ivarName withValue: anObject
	| object lazy |
	"only set instvars of ourselves and ignore those of subclasses"
	(self class instVarNames includes: ivarName) ifTrue: [
		lazy := (self lazilyInitializedVariables includes: ivarName).
		object := (self class descriptionHandler for: self) 
						adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy:lazy.
		(self class useInstVarAccessors) ifTrue: [
			self perform: ((ivarName,':') asSymbol) with: object.
		] ifFalse: [
			self instVarNamed: ivarName put: object.
		]
	].! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 17:08'!
tableDefinition
	^self class tableDefinition
	! !

!TKSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 16:15'!
tableName
	^self class tableName! !

TKSaveBase subclass: #TKSaveSimpleTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveSimpleTestObject class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:19'!
descriptionHandler
	^TKSaveSimpleDescriptionHandler! !

!TKSaveSimpleTestObject class methodsFor: 'auto-generated-description' stamp: 'test 6/16/2008 13:35'!
tableDefinition
	^super tableDefintion
		column: #testDate as: #Date;
		column: #testString as: #ByteString;
		column: #testSomething as: #TKSaveTestObject;
		column: #testInteger as: #SmallInteger.! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testDate
	^ testDate! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testDate: anObject
	testDate := anObject! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testInteger
	^ testInteger! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testInteger: anObject
	testInteger := anObject! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testSomething
	^ testSomething! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testSomething: anObject
	testSomething := anObject! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testString
	^ testString! !

!TKSaveSimpleTestObject methodsFor: 'accessing' stamp: 'tk 5/22/2008 11:18'!
testString: anObject
	testString := anObject! !

TKSaveBase subclass: #TKSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 6/16/2008 13:35'!
descriptionTestDate
	^MADateDescription new
		selectorAccessor: #testDate;
		label: 'testDate';
		default: Date today;
		persistenceDescription: ((TKSaveColumn new)
	columnName: 'testDate';
	sqlType: 'DATE');
		yourself
! !

!TKSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 6/16/2008 13:35'!
descriptionTestExtremelyDeepSubString
	^nil
! !

!TKSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 6/16/2008 13:35'!
descriptionTestInteger
	^MANumberDescription new
		selectorAccessor: #testInteger;
		label: 'testInteger';
		default: 0;
		persistenceDescription: ((TKSaveColumn new)
	columnName: 'testInteger';
	sqlType: 'SMALLINT');
		yourself
! !

!TKSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 6/16/2008 13:35'!
descriptionTestString
	^MAStringDescription new
		selectorAccessor: #testString;
		label: 'testString';
		default: '';
		persistenceDescription: ((TKSaveColumn new)
	columnName: 'testString';
	sqlType: 'VARCHAR(254)');
		yourself
! !

!TKSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 6/16/2008 13:35'!
descriptionTestSubString
	^nil
! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate
	^ testDate! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!TKSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

TKSaveTestObject subclass: #TKSaveTestObjectChild
	instanceVariableNames: 'testSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!TKSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

TKSaveTestObjectChild subclass: #TKSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!TKSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!TKSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #TKSaveDescriptionHandler
	instanceVariableNames: 'sampleObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!TKSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:50'!
for: aSampleObject
	^self new
		sampleObject: aSampleObject.! !

!TKSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 16:21'!
getInheritanceModeForClass: aClass
	^#singleTableInheritance! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 15:54'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	^self subclassResponsibility! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:11'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass
	^self subclassResponsibility! !

!TKSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/9/2008 14:07'!
createDescriptionMethods
	^self subclassResponsibility.! !

!TKSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/6/2008 16:50'!
determineSqlTypeForObject: anObject
	| connection sqlType classResolved currentClass |
	connection := self sampleObject class getConnection.
	(anObject class inheritsFrom: TKSaveBase) ifTrue: [
		sqlType := connection integer.
	] ifFalse: [
		classResolved := false.
		currentClass := anObject class.
		[classResolved or: [currentClass = Object]] whileFalse: [
			(connection respondsTo: (currentClass name withFirstCharacterDownshifted)) ifTrue: [
				sqlType := connection perform: (currentClass name withFirstCharacterDownshifted).
				classResolved := true.
			] ifFalse: [
				currentClass := currentClass superclass.
			].
		]. 
	].
	^sqlType! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:34'!
getColumnForAttribute: anAttr of: anObject
	^self subclassResponsibility! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:11'!
persistenceDescriptionForObject: anObject withLabel: aLabel
	| connection linkedClass |
	connection := self sampleObject class getConnection.
	linkedClass := (anObject class inheritsFrom: TKSaveBase) ifTrue: [anObject class] ifFalse: [nil].
	^self createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: linkedClass! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 5/22/2008 10:38'!
sampleObject
	^ sampleObject! !

!TKSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 5/22/2008 10:38'!
sampleObject: anObject
	sampleObject := anObject! !

TKSaveDescriptionHandler subclass: #TKSaveMagritteDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 14:02'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	| persistenceObject |
	aBoolean ifTrue: [
		^self error: 'create proxy object handling'
	] ifFalse: [
		(self sampleObject class respondsTo: (ivarName asDescriptionSelector) asSymbol) ifTrue: [
			persistenceObject := (self sampleObject class perform: (ivarName asDescriptionSelector)) persistenceDescription.
			^persistenceObject adaptObject: anObject.
		] ifFalse: [
			^nil
		].
		
	].
	! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 14:31'!
collectionDescriptionFor: anObject labeled: aLabel
	^self error: 'collections are not supported, yet'	! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:13'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass
	| column |
	column := TKSaveColumn new.
	column columnName: aLabel;
		sqlType: (self determineSqlTypeForObject: anObject).
	aClass ifNotNil: [column associatedClass: aClass].	
	^column creationCode! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 13:54'!
createDescriptionMethods
	| anObject |
	self sampleObject class persistedInstVars do:[ :ivn |
		(self sampleObject class includesSelector: (ivn asDescriptionSelector)) ifFalse:[
			"check this, so that instance variables of subclasses or not accidentially accessed"
			(self sampleObject class instVarNames includes: ivn) ifTrue: [
				(self sampleObject class useInstVarAccessors) ifTrue: [
					anObject := self sampleObject perform: ivn asSymbol.
				] ifFalse: [
					anObject := self sampleObject instVarNamed: ivn asSymbol.
				].
			].
			"only create the decsriptors for non nil objects"
			anObject ifNotNil: [
				self createDescriptorNamed: ivn asDescriptionSelector for: anObject withLabel: ivn.
			].
		]. 
	].! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 11:10'!
createDescriptorNamed: aSelector for: anObject withLabel: aLabel
	| code targetClass |
	targetClass := self sampleObject class.
	(targetClass organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		targetClass organization addCategory: (self descriptorMethodCategory).
	].
	code := aSelector,String cr,(self descriptorCodeFor: aLabel basedOn: anObject),String cr.
	targetClass class compile: code classified: (self descriptorMethodCategory).
	^true.
	! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 14:31'!
descriptorCodeFor: aLabel basedOn: anObject
	| className code |
	className := anObject class name.
	(anObject respondsTo: #magritteDescriptionClass) ifTrue:[
		code := self standardDescriptionCodeFor: anObject labeled: aLabel.
	] ifFalse: [
		(anObject class inheritsFrom: Collection) ifTrue: [
			code := self collectionDescriptionFor: anObject labeled: aLabel.
		] ifFalse: [
			code := self relatedObjectDescriptionFor: anObject labeled: aLabel.
		]
	].
	^code! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:53'!
descriptorMethodCategory
	^'magritte-description'! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 15:22'!
getColumnForAttribute: anAttr of: anObject
	| description |
	description := anObject perform: ('description',(anAttr at: 1 put: (anAttr at: 1))).
	
	
	! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 14:28'!
relatedObjectDescriptionFor: anObject labeled: aLabel
	| code |
	(anObject class inheritsFrom: TKSaveBase) ifTrue: [
		code := String tab, MAToOneRelationDescription name, ' new'
	] ifFalse: [
		code := String tab, '^nil'.
	].
	^code! !

!TKSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 14:07'!
standardDescriptionCodeFor: anObject labeled: aLabel
	| code |
	code := String tab,'^',anObject magritteDescriptionClass,' new', String cr, String tab, String tab.
	code := code, 'selectorAccessor: #', aLabel, ';',String cr, String tab, String tab.
	code := code, 'label: ''', aLabel,''';',String cr, String tab, String tab.
	(anObject respondsTo: #magritteDescriptionDefaultValue) ifTrue: [
		code := code, 'default: ', anObject magritteDescriptionDefaultValue, ';', String cr, String tab, String tab. 	
	].
	code := code, 'persistenceDescription: (', (self persistenceDescriptionForObject: anObject withLabel: aLabel),');',String cr, String tab, String tab.
	code := code, 'yourself'.
	^code! !

TKSaveDescriptionHandler subclass: #TKSaveSimpleDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:03'!
createDescriptionMethods
	| anObject code className |
	code := 'tableDefinition', String cr, String tab.
	code := code, '^super tableDefintion'.
	
	"(self respondsTo: #tableDefinition) ifFalse: ["
		self sampleObject class persistedInstVars do:[ :ivn |
			code := code, String cr, String tab, String tab.
			(self sampleObject class useInstVarAccessors) ifTrue: [
				anObject := self sampleObject perform: ivn asSymbol.
			] ifFalse: [
				anObject := self sampleObject instVarNamed: ivn asSymbol.
			].
			className := anObject class name.
			anObject ifNil: [
				className := 'Integer'.
			].
			code := code, 'column: #', ivn, ' as: #', className,';'.  
		].
	"]."
	code := code allButLast, '.'.
	self sampleObject class class compile: code classified: (self descriptorMethodCategory).! !

Object subclass: #TKSavePersistenceObject
	instanceVariableNames: 'associatedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

TKSavePersistenceObject subclass: #TKSaveColumn
	instanceVariableNames: 'columnName sqlType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!TKSaveColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!TKSaveColumn methodsFor: 'as yet unclassified' stamp: 'tk 6/9/2008 15:09'!
creationCode
	| code obj anyInstVarSet |
	"this is a tad hacky, since it only allows for string in the instance variables".
	"hiwever, it should be no problem, since only string are needed to describe the column properly"
	code := '(',(self class name),' new)'.
	anyInstVarSet := false.
	self class allInstVarNames do:[:ivar |
		obj := self perform: (ivar asSymbol).
		obj ifNotNil: [
			anyInstVarSet := true.
			code := code, String cr,String tab.
			code := code, ivar,': ''',obj asString,''';'.	
		].
	].
	anyInstVarSet ifTrue: [code := code allButLast].
	^code
	! !

!TKSaveColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!TKSaveColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!TKSavePersistenceObject methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:16'!
adaptObject: anObject
	self associatedClass ifNil: [
		^anObject	
	] ifNotNil: [
		^(Smalltalk at: (self associatedClass asSymbol)) findByOid: anObject 
	]! !

!TKSavePersistenceObject methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!TKSavePersistenceObject methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

TKSavePersistenceObject subclass: #TKSaveTable
	instanceVariableNames: 'tableName columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!TKSaveTable methodsFor: 'accessing' stamp: 'tk 6/6/2008 15:40'!
columns
	^ columns! !

!TKSaveTable methodsFor: 'accessing' stamp: 'tk 6/6/2008 15:40'!
columns: anObject
	columns := anObject! !

!TKSaveTable methodsFor: 'as yet unclassified' stamp: 'tk 6/6/2008 15:48'!
initialize
	columns := OrderedCollection new.! !

!TKSaveTable methodsFor: 'accessing' stamp: 'tk 6/6/2008 15:40'!
tableName
	^ tableName! !

!TKSaveTable methodsFor: 'accessing' stamp: 'tk 6/6/2008 15:40'!
tableName: anObject
	tableName := anObject! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionClass
	^#MANumberDescription! !

!Number methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:10'!
magritteDescriptionDefaultValue
	^'0'! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionStandardValue
	^0! !

!REServeMySQLDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 15:23'!
createObjectsOfClass: aClass fromResultSet: result
	| results object resultDict |
	results := OrderedCollection new.
	[result next] whileTrue: [
		object := aClass new.
		resultDict := result currentRowAsDictionary.
		aClass persistedInstVars do: [:ivar | 
			object setInstVarNamed: ivar withValue: (resultDict at: (aClass columnNameForInstVar: ivar)).
			object oid: (resultDict at: 'oid').
		].
		results add: object. 
	].
	^results! !

!REServeMySQLDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:32'!
oidColumnCreationString
	^'INT PRIMARY KEY NOT NULL AUTO_INCREMENT'! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionClass
	^#MADateDescription! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionDefaultValue
	^'Date today'! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 13:58'!
bodyForInsertOf: anObject
	| fields values |
	fields := ''.
	values := ''.
	anObject class persistedInstVars do:[ :ivn |
		fields := fields, ivn, ', '.
		values := values, (anObject escapedValueForInstanceVariable: ivn), ', '.
	].
	fields := fields allButLast:2.
	values := values allButLast:2.
	^'(',fields,') VALUES (',values,')'! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 5/13/2008 15:17'!
connectionIsAlive
	self subclassResponsibility.! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:13'!
createObject: anObject
	self executeQuery:(self queryToCreateObject: anObject).
	^self lastOidFromTable: (anObject class tableName).! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:12'!
createObjectsOfClass: aClass fromResultSet: result
	^self subclassResponsibility! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 17:20'!
database
	self subclassResponsibility.
	! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 5/22/2008 17:04'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:28'!
oidColumnCreationString
	^self subclassResponsibility! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:12'!
queryForObjectsOf: aClass byAttributes: argumentDictionary inTable: aTableName withLimit: limit 
	| query result results |
	query := 'SELECT * FROM ',aTableName,' WHERE '.
	argumentDictionary associationsDo: [:pair | 
		query := query,  pair key, ' = ', pair value asSqlValueString, ' AND '. 
	].
	query := query allButLast: 5.
	limit ifNotNil: [query := query, ' LIMIT ', limit asString].
	result := self executeQuery: query.
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results
	! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/9/2008 15:31'!
queryForTableExistance: aClassName
	| result tableExists |
	"self connection close."
	self connection initialize2.
	result := self executeQuery: 'SHOW TABLES'.
	tableExists := false.
	[result next and: [tableExists not]] whileTrue: [
		tableExists := (result valueNamed: (result columns first name)) = aClassName .
	].
	^tableExists
! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 5/22/2008 15:31'!
queryToCreateObject: anObject
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyForInsertOf: anObject). 
	^sql.! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:31'!
queryToCreateTableFromObject: anObject
	| sql ivar |
	sql := 'CREATE TABLE ',anObject class tableName, ' ('.
	sql := sql,'`oid` ',self oidColumnCreationString ,','.
	anObject class persistedInstVars do: [:ivn |
		(anObject respondsTo: ivn asSymbol) ifTrue: [
			ivar := anObject perform: ivn asSymbol.
		].
		ivar ifNil:[
			sql := sql, (self escapedRowName: ivn), (self smallInteger)
		] ifNotNil: [
			sql	:= sql, (self escapedRowName: ivn), ' ', (self perform: (ivar class reServeType)).
		].
		sql := sql, ','
	].
	sql := sql allButLast.
	sql := sql, ')'.
	^sql.! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 16:11'!
queryToRemoveTableForClass: aClass
	| sql |
	sql := 'DROP TABLE ', aClass name.
	^sql.! !

!REServeDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 17:20'!
resetDatabase
	| |
	self executeQuery: 'DROP DATABASE ', self database.
	self executeQuery: 'CREATE DATABASE ', self database.
	! !
